import type { SocketSdkReturnType } from '@socketsecurity/sdk';
export declare const ALERT_SEVERITY: Readonly<{
    readonly critical: "critical";
    readonly high: "high";
    readonly middle: "middle";
    readonly low: "low";
}>;
export type SocketSdkAlertList = SocketSdkReturnType<'getIssuesByNPMPackage'>['data'];
export type SocketSdkAlert = SocketSdkAlertList[number]['value'] extends infer U | undefined ? U : never;
export declare const ALERT_SEVERITIES_SORTED: ReadonlyArray<SocketSdkAlert['severity']>;
export declare function formatSeverityCount(severityCount: Record<SocketSdkAlert['severity'], number>): string;
export declare function getSeverityCount(issues: SocketSdkAlertList, lowestToInclude: SocketSdkAlert['severity'] | undefined): Record<SocketSdkAlert['severity'], number>;
//# sourceMappingURL=severity.d.mts.map